import javax.microedition.lcdui.*;
import java.util.Calendar;
//import com.siemens.mp.game.Light;

class LighterCanvas extends Canvas implements CommandListener {
 private Lighter midlet;
 private Display dpy;
 private Displayable prev;
 private options options;
 private errorForm er;
 private colorForm colorForm;
 private optionsForm optionsForm;
 private morzeForm morzeForm;
 private tonePlayer t = new tonePlayer ();
 public static int nextSymbol=-1, morzeLength, morzeColor, impulseColor, nextText;
 public static String morzeStr="", dashStr="";
 private static int colorNumber=0;
 private static int [] standardColors = {
  0xffffff, 0x0000ff, 0x00ff00, 0x00ffff, 0xff0000, 0xff00ff, 0xffff00,
  0x808080, 0x8080ff, 0x80ff80, 0xff8080, 0xff80ff, 0xffff80
 };
 private Graphics gbuffer; private Image screen; // 

 public static final int 
  MODE_CANVAS=0,
  MODE_COLOR1=1,
  MODE_COLOR2=2,
  MODE_MORZE=3,
  MODE_IMPULSE=4;

 public static int mode = MODE_CANVAS;
 private static int width,height;
 private Command cmdExit = new Command("", Command.EXIT, 1);
 private Command cmdColor = new Command(" RGB", Command.ITEM, 2);
 private Command cmdGradient1 = new Command(": ", Command.ITEM, 2);
 private Command cmdGradient2 = new Command(": ", Command.ITEM, 2);
 private Command cmdImpulse = new Command("", Command.ITEM, 2);
 private Command cmdMorze = new Command("", Command.ITEM, 2);
 private Command cmdOptions = new Command("", Command.ITEM, 2);
 private Command cmdAbout = new Command(" ", Command.ITEM, 2);

 public LighterCanvas (Lighter midlet) {
  this.midlet = midlet;
  dpy = Display.getDisplay(midlet);
  prev = dpy.getCurrent();
  options = new options (false);
  setFullScreenMode (true);
  width=getWidth();
  height=getHeight();
  mode = MODE_CANVAS;
  addCommand(cmdExit);
  addCommand(cmdColor);
  addCommand(cmdGradient1);
  addCommand(cmdGradient2);
  addCommand(cmdImpulse);
  addCommand(cmdMorze);
  addCommand(cmdOptions);
  addCommand(cmdAbout);
  setCommandListener(this);
  //dpy.flashBacklight(Integer.MAX_VALUE); 
  //, .    Siemens S75   . 
  //MIDP 2.0 -    ;       MIDP 2.0, , 
  //Light.setLightOn();
  screen=Image.createImage(width,height); // 
  gbuffer=screen.getGraphics(); 
 }

 public int abs (int a) { return (a>0 ? a : -a); }

 private void drawGradient (Graphics graphics, int c1, int c2) {
  int r1=colorForm.getRed (c1);
  int r2=colorForm.getRed (c2);
  int g1=colorForm.getGreen (c1);
  int g2=colorForm.getGreen (c2);
  int b1=colorForm.getBlue (c1);
  int b2=colorForm.getBlue (c2);
  int r,g,b;
  for (int i=0; i<height; i++) {
   r=r1+(i-height+1)*(r2-r1)/(height-1)+(r2-r1);
   g=g1+(i-height+1)*(g2-g1)/(height-1)+(g2-g1);
   b=b1+(i-height+1)*(b2-b1)/(height-1)+(b2-b1);
   graphics.setColor (r,g,b);
   graphics.drawLine (0,i,width-1,i);
  }
 }

 protected void paint (Graphics g) {
  switch (mode) {
   case MODE_CANVAS:
    g.setColor(options.color1);
    g.fillRect(0,0,width,height);
    midlet.animateTo (midlet.timerInterval);
   break;
   case MODE_IMPULSE:
    gbuffer.setColor(impulseColor); // 
    gbuffer.fillRect(0,0,width,height);
    g.drawImage(screen,0,0,g.TOP|g.LEFT);
    if (impulseColor==options.color1) {
     impulseColor=options.color1^0xffffff;
     if (options.vibrator>0) dpy.vibrate (midlet.timerInterval); //MIDP 2.0
    }
    else {
     impulseColor=options.color1;
    }
    midlet.animateTo (midlet.timerInterval);
   break;
   case MODE_COLOR1:
   case MODE_COLOR2:
    drawGradient (g,options.gColor1,options.gColor2);
    midlet.animateTo (midlet.timerInterval);
   break;
   case MODE_MORZE:
    if (nextSymbol>-1) {
     if (nextSymbol==0) {
      morzeLength=dashStr.length();
      nextText=0;
     }
     char c=dashStr.charAt (nextSymbol++);
     int time=0;
     switch (c) {
      case '.': time=options.dot; morzeColor=0xffffff; break;
      case '-': time=options.dash; morzeColor=0xffffff; break;
      case '0': time=options.dot; morzeColor=0x000000; break;
      case '1': time=options.dash*2; morzeColor=0x000000; nextText++; break;
      case '2': time=options.dash*4; morzeColor=0x000000; nextText+=2; break;
     }
     g.setColor(morzeColor);
     g.fillRect(0,0,width,height);

     if (nextText<morzeStr.length ()) {
      String s=""+morzeStr.charAt(nextText);
      g.setColor(morzeColor^0xffffff);
      g.drawString(s, width/2, height/2 - 10, Graphics.TOP|Graphics.HCENTER);
      int k=morzeForm.letters.indexOf (morzeStr.charAt(nextText));
      if (k==-1) k=morzeForm.lowerStr.indexOf (morzeStr.charAt(nextText));
      if (k>-1) {
       s=morzeForm.codes[morzeForm.numbers[k]];
       g.drawString(s, width/2, height/2 + 10, Graphics.TOP|Graphics.HCENTER);
      }
     }
     midlet.animateTo (time);

     if ((c=='.') || (c=='-')) {
      if (options.vibrator>0) dpy.vibrate (time); //MIDP 2.0
      if (options.sound>0) {
       if (c=='.') t.setDuration (options.dot);
       else t.setDuration (options.dash);
       t.play (options.note);
      }
     }

     if (nextSymbol==morzeLength) {
      if (options.morzeCycle>0) nextSymbol=0;
      else {
       nextSymbol=-1;
       mode=MODE_CANVAS;
      }
     }
    }
   break;
  }
 }
    
 public void commandAction(Command c, Displayable d)  {
  if (c==cmdExit) {
   midlet.exitMIDlet();
  }
  else if (c==cmdColor) {
   mode=MODE_CANVAS;
   colorForm = new colorForm (midlet, " ", options.color1);
   dpy.setCurrent (colorForm);
  }
  else if (c==cmdGradient1) { 
   mode=MODE_COLOR1;
   colorForm = new colorForm (midlet, "  1", options.gColor1);
   dpy.setCurrent (colorForm);
  }
  else if (c==cmdGradient2) { 
   mode=MODE_COLOR2;
   colorForm = new colorForm (midlet, "  2", options.gColor2);
   dpy.setCurrent (colorForm);
  }
  else if (c==cmdImpulse) {
   mode=MODE_IMPULSE;
   impulseColor=options.color1;
  }
  else if (c==cmdOptions) {
   optionsForm = new optionsForm (midlet);
   dpy.setCurrent (optionsForm);
  }
  else if (c==cmdMorze) {
   mode=MODE_MORZE;
   nextSymbol=-1;
   morzeForm = new morzeForm (midlet);
   dpy.setCurrent (morzeForm);
  }
  else if (c==cmdAbout) {
   er=new errorForm (dpy," ");
   er.show (
    "Lighter - -\n"+
    " RGB -   ,    ,     .  1 -    \n"+
    ":   :  -      ()\n"+
    " -   .      *,  - #,    - 0\n"+
    " -      , ,  ,     (. ).       SOS  2\n"+
    "          ,  ,     \n"+
    "(C) PerS (pers@mail.ru)"
   );
  }
  repaint ();
 }

 public void keyPressed(int keyCode) {
  switch (keyCode) {            
   case Canvas.KEY_STAR:
    if (midlet.timerInterval<5000) midlet.timerInterval+=100;
   break;
   case Canvas.KEY_POUND:
    if (midlet.timerInterval>100) midlet.timerInterval-=100;
   break;
   case Canvas.KEY_NUM0:
    midlet.timerInterval=1000;
   break;
   case Canvas.KEY_NUM1: //1- 
    mode=MODE_CANVAS;
    if (colorNumber == standardColors.length-1) colorNumber=0;
    else colorNumber++;
    options.color1=standardColors[colorNumber];
    repaint();
   break;
   case Canvas.KEY_NUM2: //2-SOS
    mode=MODE_MORZE;
    nextSymbol=0;
    morzeStr="SOS";
    dashStr=".0.0.1-0-0-1.0.0.2";
    repaint();
   break;
  }
 }

}
